import { buildUUID } from '../../../utils/uuid';
import { ApiAction, ApiActionPage } from '../../model/baseModel';
import {
  MaterialReqListItem,
  MaterialReqPageListGetResultModel,
  MaterialReqDetailPageListGetResultModel,
  MaterialReqDetailSNPageListGetResultModel,
  MaterialReqDetailPageParams,
  MaterialReqDetailSNPageParams,
  MaterialReqPageParams,
} from '../model/warehoueseModel';
import { genAction, Api, genActionPage } from '../system';
import { useUserStore } from '/@/store/modules/user';
import { defHttp } from '/@/utils/http/axios';
import { isNullOrEmpty } from '/@/utils/is';

/*
 * 获取领料单分页列表
 */
export const getMaterialReqListByPage = async (params: any) => {
  let order = ''
  if (params.order != undefined) {
    order = params.order == 'descend' ? (params.field + ' desc') : params.field
  }
  let sqlcmd = '1=1';
  if (params?.BILLCODE != undefined && params?.BILLCODE != '') {
    sqlcmd += " And BILLCODE like '%" + params?.BILLCODE + "%'";
  }
  // 日期
  if (params?.BILLDATE != undefined && params?.BILLDATE != '') {
    sqlcmd += " And BILLDATE > '" + params?.BILLDATE[0] + "'";
  }
  if (params?.BILLDATE != undefined && params?.BILLDATE != '') {
    sqlcmd += " And BILLDATE < '" + params?.BILLDATE[1] + "'";
  }

  if (params?.UPDATE_TIME != undefined && params?.UPDATE_TIME != '') {
    sqlcmd += " And UPDATE_TIME > '" + params?.UPDATE_TIME[0] + "'";
  }
  if (params?.UPDATE_TIME != undefined && params?.UPDATE_TIME != '') {
    sqlcmd += " And UPDATE_TIME < '" + params?.UPDATE_TIME[1] + "'";
  }
  if (!isNullOrEmpty(params?.STATUS)) {
    sqlcmd += " And STATUS = '" + params?.STATUS + "'";
  }
  if (!isNullOrEmpty(params?.BIZTYPE)) {
    sqlcmd += " And BIZTYPE = '" + params?.BIZTYPE + "'";
  }
  //下拉
  // if (params?.BILLDATE != undefined && params?.BILLDATE != '') {
  //   sqlcmd += "And BILLDATE like '%" + params?.BILLDATE + "%'";
  // }
  var option ={
    UserId:useUserStore().getUserInfo.userId as string,
    ByOrg:true,
    OrgCode:useUserStore().getUserInfo.orgCode as string
  }

  if(!isNullOrEmpty(params.page)){
    const usParams = genAction('BIZ_ERP_PROD_OUT', {
      QueryAble_T: '',
      where: sqlcmd,
      order: order,
      page: {
        pageAble_T: 'string',
        draw: 1,
        pageIndex: params.page,
        pageSize: params.pageSize,
      }
    },
    option);
    return getMaterialReqListByPageAsync(usParams);
  }else{
    const usParams = genAction('BIZ_ERP_PROD_OUT', {
      QueryAble_T: '',
      where: sqlcmd
    },
    option);
    return getMaterialReqListByPageAsync(usParams);
  }

  // const usParams = genAction('BIZ_ERP_PROD_OUT', {
  //   QueryAble_T: '',
  //   where: sqlcmd,
  //   order: order,
  //   page: {
  //     pageAble_T: 'string',
  //     draw: 1,
  //     pageIndex: params.page,
  //     pageSize: params.pageSize,
  //   }
  // },
  // option);
  // return getMaterialReqListByPageAsync(usParams);
};
async function getMaterialReqListByPageAsync(params: any) {
  const data = await defHttp.post(
    { url: Api.QueryUrl, params },
    {
      isTransformResponse: false,
    },
  );
  let model = {}
  if(isNullOrEmpty(data.Data.page)){
     model = {
      items: data.Data.Items,
    };
  }else{
      model = {
      items: data.Data.page.data,
      total: data.Data.page.totals,
    };
  }
  
  return model;
}

export const SaveProd = async (params: any) => {
  var option ={
    UserId:useUserStore().getUserInfo.userId as string,
    ByOrg:true,
    OrgCode:useUserStore().getUserInfo.orgCode as string
  }
  let data;
  params.ERP_BILL_CODE='用户：'+option.UserId+'确认T100已经过账';
  params.STATUS=4;
  {
    data = await defHttp.post(
      { url: Api.UpdateEntity, params: genAction('BIZ_ERP_PROD_OUT', params) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
  } 
  return data;
};

export const UpdateReq = async (params: any) => {
  var option ={
    UserId:useUserStore().getUserInfo.userId as string,
    ByOrg:true,
    OrgCode:useUserStore().getUserInfo.orgCode as string
  }
  let data;
  {
    data = await defHttp.get(
      { url: Api.UpdateReq, params: {User:option.UserId,BillCode:params,Auth_Org:option.OrgCode} },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
  } 
  return data;
};

//领料单明细
export const getMaterialReqDetailListByPage = async (params: MaterialReqDetailPageParams) => {
  let order = ''
  if (params.order != undefined) {
    order = params.order == 'descend' ? (params.field + ' desc') : params.field
  }
  let sqlcmd = '1=1';
  if (params?.BILLCODE != undefined && params?.BILLCODE != '') {
    sqlcmd += " And BILLCODE like '%" + params?.BILLCODE + "%'";
  }
  if (params?.ITEM_CODE != undefined && params?.ITEM_CODE != '') {
    sqlcmd += " And ITEM_CODE like '%" + params?.ITEM_CODE + "%'";
  }
  //下拉
  // if (params?.BILLDATE != undefined && params?.BILLDATE != '') {
  //   sqlcmd += "And BILLDATE like '%" + params?.BILLDATE + "%'";
  // }
  var option ={
    UserId:useUserStore().getUserInfo.userId as string,
    ByOrg:true,
    OrgCode:useUserStore().getUserInfo.orgCode as string
  }
  
  //const rParams = genActionPage('V_BIZ_ERP_PROD_OUT_DTL', sqlcmd, params.page, params.pageSize,option);
  // const usParams = genAction('V_BIZ_ERP_PROD_OUT_DTL', {
  //   QueryAble_T: '',
  //   where: sqlcmd,
  //   order: 'BILLLINE*1',
  //   page: {
  //     pageAble_T: 'string',
  //     draw: 1,
  //     pageIndex: params.page,
  //     pageSize: params.pageSize,
  //   },
  //   option
  // });
  // return getMaterialReqDetailListByPageAsync(usParams);
  if(!isNullOrEmpty(params.page)){
    const usParams = genAction('V_BIZ_ERP_PROD_OUT_DTL', {
      QueryAble_T: '',
      where: sqlcmd,
      order:'BILLLINE*1' + order,
      page: {
        pageAble_T: 'string',
        draw: 1,
        pageIndex: params.page,
        pageSize: params.pageSize,
      }
    },
    option);
    return getMaterialReqDetailListByPageAsync(usParams);
  }else{
    const usParams = genAction('V_BIZ_ERP_PROD_OUT_DTL', {
      QueryAble_T: '',
      where: sqlcmd
    },
    option);
    return getMaterialReqDetailListByPageAsync(usParams);
  }
};
async function getMaterialReqDetailListByPageAsync(params: any) {
  const data = await defHttp.post(
    { url: Api.QueryUrl, params },
    {
      isTransformResponse: false,
    },
  );
  let model = {}
  if(isNullOrEmpty(data.Data.page)){
     model = {
      items: data.Data.Items,
    };
  }else{
      model = {
      items: data.Data.page.data,
      total: data.Data.page.totals,
    };
  }
  
  return model;
}
export const getMaterialReqDetailSNListByPage = async (params: MaterialReqDetailSNPageParams) => {
  let order = ''
  if (params.order != undefined) {
    order = params.order == 'descend' ? (params.field + ' desc') : params.field
  }
  let sqlcmd = '1=1';
  if (params?.BILLCODE != undefined && params?.BILLCODE != '') {
    sqlcmd += " And ORDER_NO like '%" + params?.BILLCODE + "%'";
  }
  if (params?.ITEM_CODE != undefined && params?.ITEM_CODE != '') {
    sqlcmd += " And ITEM_CODE like '%" + params?.ITEM_CODE + "%'";
  }
  if (params?.SN != undefined && params?.SN != '') {
    sqlcmd += " And SN like '%" + params?.SN + "%'";
  }
  if (params?.STATUS != undefined && params?.STATUS != '') {
    sqlcmd += " And STATUS = '" + params?.STATUS + "'";
  }
  if (params?.BIZTYPE != undefined && params?.BIZTYPE != '') {
    sqlcmd += " And BIZTYPE = '" + params?.BIZTYPE + "'";
  }
  //下拉
  // if (params?.BILLDATE != undefined && params?.BILLDATE != '') {
  //   sqlcmd += "And BILLDATE like '%" + params?.BILLDATE + "%'";
  // }
  var option ={
    UserId:useUserStore().getUserInfo.userId as string,
    ByOrg:true,
    OrgCode:useUserStore().getUserInfo.orgCode as string
  }
  if(!isNullOrEmpty(params.page)){
    const usParams = genAction('BIZ_ERP_PROD_OUT_SN', {
      QueryAble_T: '',
      where: sqlcmd,
      order: order,
      page: {
        pageAble_T: 'string',
        draw: 1,
        pageIndex: params.page,
        pageSize: params.pageSize,
      }
    },
    option);
    return getMaterialReqDetailSNListByPageAsync(usParams);
  }else{
    const usParams = genAction('BIZ_ERP_PROD_OUT_SN', {
      QueryAble_T: '',
      where: sqlcmd
    },
    option);
    return getMaterialReqDetailSNListByPageAsync(usParams);
  }
  // const rParams = genActionPage('BIZ_ERP_PROD_OUT_SN', sqlcmd, params.page, params.pageSize,option);
  // return getMaterialReqDetailSNListByPageAsync(rParams);
};
async function getMaterialReqDetailSNListByPageAsync(params: any) {
  const data = await defHttp.post(
    { url: Api.QueryUrl, params },
    {
      isTransformResponse: false,
    },
  );
  let model = {}
  if(isNullOrEmpty(data.Data.page)){
     model = {
      items: data.Data.Items,
    };
  }else{
      model = {
      items: data.Data.page.data,
      total: data.Data.page.totals,
    };
  }
  
  return model;
}
//下拉列表
// STATUSs 单据状态
// BIZTYPEs 单据类型
export const optionsListApi = async (params: Recordable) => {
  const usParams = genAction('BIZ_ERP_PROD_OUT+STATUSs', '');
  return await defHttp.post(
    { url: Api.urlQueryEnum, params: usParams },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
      // apiUrl: globSetting.taskApiUrl
    },
  );
};
export const optionTypeListApi = async (params: Recordable) => {
  const usParams = genAction('BIZ_ERP_PROD_OUT+BIZTYPEs', '');
  return await defHttp.post(
    { url: Api.urlQueryEnum, params: usParams },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
      // apiUrl: globSetting.taskApiUrl
    },
  );
};
